%define lib_name_orig	libpng
%define major		3
%define lib_name	%mklibname png %{major}
%define lib_devel	%mklibname png -d
%define lib_static	%mklibname png -d -s
%define subrel		3

Summary: 	A library of functions for manipulating PNG image format files
Name: 		libpng
Version: 	1.2.22
Release:	%mkrel 0
License: 	GPL-like
Group: 		System/Libraries
BuildRequires: 	zlib-devel
URL: 		http://www.libpng.org/pub/png/libpng.html
Source: 	http://prdownloads.sourceforge.net/libpng/%{name}-%{version}.tar.bz2
Patch0:		libpng-1.2.19-makefile.patch
Patch1:		libpng-1.2.22-lib64.patch
Patch2:		libpng-1.2.22-CVE-2008-1382.patch
Patch3:		libpng-1.2.22-CVE-2008-3964.diff
Patch4:		libpng-1.2.18-CVE-2008-5907.patch
Patch5:		libpng-1.2.22-CVE-2009-0040.diff
Epoch: 		2
Buildroot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The libpng package contains a library of functions for creating and
manipulating PNG (Portable Network Graphics) image format files.  PNG is
a bit-mapped graphics format similar to the GIF format.  PNG was created to
replace the GIF format, since GIF uses a patented data compression
algorithm.

Libpng should be installed if you need to manipulate PNG format image
files.

%package -n	%{lib_name}
Summary:	A library of functions for manipulating PNG image format files
Group:		System/Libraries
Obsoletes:	%{lib_name_orig}
Provides:	%{lib_name_orig} = %{epoch}:%{version}-%{release}

%description -n	%{lib_name}
This package contains the library needed to run programs dynamically
linked with libpng.

%package -n	%{lib_devel}
Summary:	Development tools for programs to manipulate PNG image format files
Group:		Development/C
Requires:	%{lib_name} = %{epoch}:%{version}-%{release}
Requires:	zlib-devel
Provides:	%{lib_name_orig}-devel = %{epoch}:%{version}-%{release}
Provides:	png-devel = %{epoch}:%{version}-%{release}
Obsoletes:	%mklibname png 3 -d
Provides:	%mklibname png 3 -d

%description -n	%{lib_devel}
The libpng-devel package contains the header files and libraries
necessary for developing programs using the PNG (Portable Network
Graphics) library.

If you want to develop programs which will manipulate PNG image format
files, you should install libpng-devel.  You'll also need to install the
libpng package.

%package -n	%{lib_static}
Summary:	Development static libraries
Group:		Development/C
Requires:	%{lib_name_orig}-devel = %{epoch}:%{version}-%{release}
Requires:	zlib-devel
Provides:	%{lib_name_orig}-static-devel = %{epoch}:%{version}-%{release}
Provides:	png-static-devel = %{epoch}:%{version}-%{release}
Obsoletes:	%mklibname png 3 -d -s
Provides:	%mklibname png 3 -d -s

%description -n	%{lib_static}
Libpng development static libraries.

%package -n	%{lib_name_orig}-source
Summary:	Source code of %{lib_name_orig}
Group:		Development/C

%description -n	%{lib_name_orig}-source
This package contains the source code of %{lib_name_orig}.

%prep
%setup -q
%patch0 -p1 -b .makefile
%patch1 -p1 -b .lib64
%patch2 -p1 -b .cve-2008-1382
%patch3 -p0 -b .CVE-2008-3964
%patch4 -p0 -b .CVE-2008-5907
%patch5 -p1 -b .CVE-2009-0040

perl -pi -e 's|^prefix=.*|prefix=%{_prefix}|' scripts/makefile.linux
perl -pi -e 's|^(LIBPATH=.*)/lib\b|\1/%{_lib}|' scripts/makefile.linux
ln -s scripts/makefile.linux ./Makefile

%build
%ifarch x86_64
export CFLAGS="%{optflags} -DPNG_NO_MMX_CODE"
%else
export CFLAGS="%{optflags}"
%endif

%configure2_5x
make

%check
make check

%install
rm -rf %{buildroot}
%makeinstall_std

install -d %{buildroot}%{_mandir}/man{3,5}
install -m0644 {libpng,libpngpf}.3 %{buildroot}%{_mandir}/man3
install -m0644 png.5 %{buildroot}%{_mandir}/man5/png3.5

install -d %{buildroot}%{_prefix}/src/%{lib_name_orig}
cp -a *.c *.h %{buildroot}%{_prefix}/src/%{lib_name_orig}

# remove unpackaged files
rm -rf %{buildroot}{%{_prefix}/man,%{_libdir}/lib*.la}

#multiarch
%multiarch_binaries %{buildroot}%{_bindir}/libpng12-config

%post -n %{lib_name} -p /sbin/ldconfig

%postun -n %{lib_name} -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files -n %{lib_name}
%defattr(-,root,root)
%{_libdir}/*.so.%{major}*
%{_libdir}/libpng12.so.*

%files -n %{lib_devel}
%defattr(-,root,root)
%doc *.txt example.c README TODO CHANGES
%{_bindir}/libpng-config
%{_bindir}/libpng12-config
%multiarch %{multiarch_bindir}/libpng12-config
%{_includedir}/*
%{_libdir}/libpng12.so
%{_libdir}/libpng.so
%{_libdir}/pkgconfig/*
%{_mandir}/man3/*
%{_mandir}/man5/*

%files -n %{lib_static}
%defattr(-,root,root)
%doc README
%{_libdir}/libpng*.a

%files -n %{lib_name_orig}-source
%defattr(-,root,root)
%{_prefix}/src/%{lib_name_orig}


%changelog
* Mon Feb 23 2009 Oden Eriksson <oeriksson@mandriva.com> 1.2.22-0.3mdv2008.0
- P3: security fix for CVE-2008-3964
- P4: security fix for CVE-2008-5907
- P5: security fix for CVE-2009-0040

* Mon Jul 28 2008 Vincent Danen <vdanen@mandriva.com> 1.2.22-0.2mdv2008.0
- P2: security fix for CVE-2008-1382

* Tue Nov 12 2007 Vincent Danen <vdanen@mandriva.com> 1.2.22-0.1mdv2008.0
- 1.2.22: fixes CVE-2007-5266, CVE-2007-5268, CVE-2007-5269, 
- rediff P1

* Sat Aug 25 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 1.2.19-2mdv2008.0
+ Revision: 71324
- remove wrong obsoletes

* Sat Aug 25 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 2:1.2.19-1mdv2008.0
+ Revision: 71212
- export -DPNG_NO_MMX_CODE for x86_64 arch
- correct requires and provides
- rediff patch 0
- new devel library policy
- drop patch 2 (there is better way)
- new version

* Mon Aug 06 2007 David Walluck <walluck@mandriva.org> 2:1.2.18-3mdv2008.0
+ Revision: 59535
- move %%{_mandir}/man5/* to devel package in order to avoid multiarch conflict

* Mon Jul 02 2007 Olivier Blin <oblin@mandriva.com> 2:1.2.18-2mdv2008.0
+ Revision: 47129
- add a libpng-source package (to be used for software rebuilding libpng, such as syslinux)
- remove obsolete conflicts

* Wed May 16 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2:1.2.18-1mdv2008.0
+ Revision: 27297
- Updated to 1.2.18.

* Fri Apr 20 2007 Olivier Blin <oblin@mandriva.com> 2:1.2.16-1mdv
+ Revision: 16258
- 1.2.16


* Sun Feb 18 2007 Götz Waschk <waschk@mandriva.org> 1.2.13-2mdv2007.0
+ Revision: 122407
- fix buildrequires

* Fri Nov 17 2006 Olivier Blin <oblin@mandriva.com> 2:1.2.13-1mdv2007.1
+ Revision: 85128
- 1.2.13

* Tue Oct 31 2006 Oden Eriksson <oeriksson@mandriva.com> 2:1.2.12-5mdv2007.1
+ Revision: 74600
- rebuild
- bzip2 cleanup
- rebuild

* Thu Oct 12 2006 Oden Eriksson <oeriksson@mandriva.com> 2:1.2.12-3mdv2007.1
+ Revision: 63449
- bunzip patches
- Import libpng

* Thu Aug 03 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.2.12-2mdv2007.0
- Drop broken x86_64 patches (including from #23692). Time to be spent
  for making the MMX code 64-bit safe is the same as writing correct
  SSE2+ code. And, without proper data for validating semantics and
  performance, this currently is not worth the effort for MDV2007.0
- Henceforth, make sure to enable MMX optimisations on 32-bit x86
  platforms only (Patch2)

* Sun Jul 02 2006 Giuseppe Ghib <ghibo@mandriva.com> 1.2.12-1mdv2007.0
- Release 1.2.12.
- Added Patch2 from Alex Simon to allow Assembler support in pnggccrd.c
  (needs Gwenole review), to allow ImageMagick 6.2.8.1 building on X86-64.

* Sun Jun 18 2006 Warly <warly@mandriva.com>  1.2.10-4mdv2007.0
- This seem to be a desired behavior, need to recompile the packages requiring the old devel(libpng)

* Sun Jun 18 2006 Warly <warly@mandriva.com>  1.2.10-3mdv2007.0
- also workarround the problem for x86_64

* Sat Jun 17 2006 Warly <warly@mandriva.com>  1.2.10-2mdv2007.0
- workarround the non providing of devel(libpng)

* Fri Jun 16 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.2.10-1mdv2007.0
- 1.2.10
- do configure
- %%mkrel
- regenerate P0 & P1
- move tests to new %%check stage
- multiarch

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 1.2.8-2mdk
- Rebuild

* Wed Dec 22 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.8-1mdk
- 1.2.8
- fix summary-ended-with-dot

* Tue Nov 09 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.2.7-1mdk
- new release

* Fri Oct 01 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.6-2mdk
- lib64 fixes to pkgconfig files

* Wed Aug 18 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.2.6-1mdk
- new release
- fix url
- kill patch 1 (merged upstream)

* Fri Jun 18 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.5-11mdk
- security fix for CAN-2004-0421 (Vincent Danen)
- misc spec file fixes

